#include	"dv_repeater.h"


int	read_config(int argc, char **argv)
{
	char	buff[256];
	char	*delmi = "=\n\r\t\0";
	char	*pnt;
	char	*p;
	int	n;
	int	field_sw;
	int	port;

	FILE	*config_file;

	if (argc == 2)
	{
		config_file = fopen (argv[1], "r");
		if (!config_file)
		{
			time(&cur_time);
			fprintf (log_file, "%24.24s config file not found (%s)\n", ctime(&cur_time), argv[1]);
			fflush (log_file);
			return FALSE;
		}
	} 
	else
	{
		config_file = fopen (CONFIG_FILE,"r");
		if (!config_file)
		{
			time(&cur_time);
			fprintf (log_file, "%24.24s config file not found (%s)\n", 
						ctime(&cur_time), CONFIG_FILE);
			fflush (log_file);
			return FALSE;
		}
	}

	while (fgets (buff, 255, config_file))
	{
		if (buff[0] != '#')
		{
			n = 0;
			while (buff[n] == 0x20) n++;
			p = strtok(&buff[n], delmi);
			if (p != NULL)
			{
				pnt = strtok(NULL, delmi);
	
				if (!memcmp (p, "REPEATER_CALLSIGN", 17))
				{
                                        memset (area_rep_callsign, 0x20, 8);
                                        while (*pnt)
                                        {
                                        	area_rep_callsign[n++] = *pnt;
						if (n > 7) break;
                                                pnt++;
                                        }
					memcpy (gateway_callsign, area_rep_callsign, 7);
					gateway_callsign[7] = 'G';
					memcpy (sys_call, area_rep_callsign, 7);
					sys_call[7] = 'S';
				}
				else if (!memcmp (p, "DEBUG", 5))
				{
					debug = atoi (pnt);
				}
				else if (!memcmp (p, "MONITOR", 7))
                                {
                                        n = 0;
                                        field_sw = 0;
                                        port = 0;
                                        memset (monitor_name, 0x20, 128);
                                        while (*pnt)
                                        {
                                                if (*pnt == ':') field_sw++;
                                                else
                                                {
                                                        switch (field_sw)
                                                        {
                                                                case 1:
                                                                        if (isdigit (*pnt)) port = port * 10 + *pnt - '0';
                                                                        break;
                                                                case 0:
                                                                        if (*pnt != 0x20) monitor_name[n++] = *pnt;
                                                                        if (n > 127) n = 127;
                                                                        break;
                                                        }
                                                }
                                                pnt++;
                                        }
                                        if (n && (port > 0))
                                        {
                                                monitor_name[n] = 0x00;
                                                monitor_port = port;
                                        }
                                        else
                                        {
                                                time (&cur_time);
                                                fprintf (log_file, "%24.24s Invalid Format of MONITORY\n",
                                                                                ctime(&cur_time));
                                                fflush (log_file);
                                                monitor_port = 0;
                                        }
                                }
				else if (!memcmp (p, "REPEATER", 8))
				{
					repeater = atoi (pnt);
				}
				else if (!memcmp (p, "INTERVAL", 8))
				{
					sys_timeout.tv_sec = atoi (pnt);
					sys_timeout.tv_usec = 0;
					if (sys_timeout.tv_sec < 10) sys_timeout.tv_sec = 10;
				}
                                else if (!memcmp (p, "GATEWAY", 7))
                                {
                                        n = 0;
                                        field_sw = 0;
                                        port = 0;
                                        memset (gateway_name, 0x20, 128);
                                        while (*pnt)
                                        {
                                                if (*pnt == ':') field_sw++;
                                                else
                                                {
                                                        switch (field_sw)
                                                        {
                                                                case 1:
                                                                        if (isdigit (*pnt)) port = port * 10 + *pnt - '0';
                                                                        break;
                                                                case 0:
                                                                        if (*pnt != 0x20) gateway_name[n++] = *pnt;
                                                                        if (n > 127) n = 127;
                                                                        break;
                                                        }
                                                }
                                                pnt++;
                                        }
                                        if (n && (port > 0))
                                        {
                                                gateway_name[n] = 0x00;
                                                gateway_port = port;
                                        }
                                        else
                                        {
                                                time (&cur_time);
                                                fprintf (log_file, "%24.24s Invalid Format of GATEWAY\n",
                                                                                ctime(&cur_time));
                                                fflush (log_file);
                                                gateway_port = 0;
                                        }
                                }

				else if (!memcmp (p, "NODE_ADAPTER",12))
				{
					pnt = strtok(pnt, ":");
					VenderID = htoi (pnt);
					pnt = strtok(NULL, delmi);
					ProductID = htoi(pnt);
				}
				else
				{
					time (&cur_time);
					fprintf (log_file, "%24.24s Error on config file : %s\n",ctime(&cur_time), buff);
					fflush (log_file);
				}
			}
		}
	}

	fclose (config_file);

	return TRUE;
}

	
